package fxLangat;


import java.net.URL;
import java.util.List;
import java.util.ResourceBundle;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import langat.Kera;
import langat.Kohteet;
import langat.Langat;
import fi.jyu.mit.fxgui.Dialogs;
/**
 * @author Käyttäjä
 * @version 12.4.2025
 *
 */
public class LanganmuokkausController implements ModalControllerInterface<Kera>,Initializable{

    @FXML private ComboBoxChooser<?> editVari;
    @FXML private ComboBoxChooser<?> editMateriaali;
    @FXML private ComboBoxChooser<?> editKaytto;
    @FXML private ComboBoxChooser<?> editKohteet;
    @FXML private TextField editMaara;
    @FXML private TextArea areaHyodynnys;
    
    @Override
    public void initialize(URL arg0, ResourceBundle arg1) {
        alusta();
        
    }
    
    @FXML private void handleOK() {
        if ( keraKohdalla != null && keraKohdalla.getVariInd()==0 ||
                keraKohdalla.getMateriaaliInd()==0 ||
                keraKohdalla.getKayttoInd()==0) {
            naytaVirhe("Kenttä ei saa olla tyhjä");
            return;
        }

        ModalController.closeStage(LabelVirhe);
    }

    
    @FXML private void handleCancel() {
        keraKohdalla = null;
        ModalController.closeStage(LabelVirhe);
    }

    @FXML private Label LabelVirhe;
    
    // ========================================================    
    private Kera keraKohdalla;    
    private Langat langat;
    private ComboBoxChooser<?> edits[];
    private LangatGUIController langatgui;
    private StringBuilder sb = new StringBuilder();
    
    @Override
    public Kera getResult() {
        // TODO Auto-generated method stub
        return keraKohdalla;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
    }

    @Override
    public void setDefault(Kera oletus) {
        keraKohdalla = oletus;
        naytaKera(edits,keraKohdalla);

        
    }
    
    /**
    * Tekee tarvittavat muut alustukset.
    */
    protected void alusta() {
        edits = new ComboBoxChooser<?>[]{editVari, editMateriaali, editKaytto};
        
        editMaara.setOnKeyReleased( e -> kasitteleMuutosMaaraan((TextField)(e.getSource())));
        
        editKohteet.getSelectionModel().selectedItemProperty().addListener((obs, oldVal, newVal) -> {
            if (newVal != null) {
                kasitteleMuutosKohteeseen();
            }
        });
        for (int i = 0; i < edits.length; i++) {
            final int index = i;
            edits[i].getSelectionModel().selectedIndexProperty().addListener((obs, oldVal, newVal) -> {
                kasitteleMuutosKeraan(index, edits[index]);
            });
        }
    }

   private void kasitteleMuutosMaaraan(TextField edit) {
       if (keraKohdalla == null) return;
       String s = edit.getText();
       String virhe = null;
       virhe = keraKohdalla.setMaara(s);
       if (virhe == null) {
           Dialogs.setToolTipText(edit,"");
           edit.getStyleClass().removeAll("virhe");
           naytaVirhe(virhe);
       } else {
           Dialogs.setToolTipText(edit,virhe);
           edit.getStyleClass().add("virhe");
           naytaVirhe(virhe);
       }
   }

   /**
    * uusi kohde
   */
   
   private void kasitteleMuutosKohteeseen() {
       if ( keraKohdalla == null ) return;  
       Kohteet kohd = new Kohteet();  
         
       
       int combNro=editKohteet.getSelectedIndex();
       if (combNro!=0) {
           kohd.taytaKohd(keraKohdalla.getTunnusNro(),combNro); 
           kohdeTarkistus(kohd);
           kohd.rekisteroi();
           areaHyodynnys.setText(sb.toString());
           langatgui.hae(keraKohdalla.getTunnusNro()); 
       }
   }
   
    private void kohdeTarkistus(Kohteet kohd) {
        String s = kohd.getKohde();
        int index = sb.indexOf(s);
        if (index != -1) {
            sb.delete(index, index + s.length()+1);
            langat.poista(kohd);
        }
        else {
            sb.append(kohd.toString(kohd)+"\n");
            langat.lisaa(kohd); 
            
        }
    }

/**
    * Käsitellään kerään tullut muutos
    * @param edit muuttunut kenttä
    */
   private void kasitteleMuutosKeraan(int k, ComboBoxChooser<?> edit) {
       if (keraKohdalla == null || edit == null) return;

       int ind = edit.getSelectedIndex();
       if (ind < 0) return;

       switch (k) {
           case 0: keraKohdalla.setVariInd(ind); break;
           case 1: keraKohdalla.setMateriaaliInd(ind); break;
           case 2: keraKohdalla.setKayttoiInd(ind); break;
           default: return;
       }
       
       
       Dialogs.setToolTipText(edit, "");
       edit.getStyleClass().removeAll("virhe");
       naytaVirhe(null);
   }
   
   
    private void naytaVirhe(String virhe) {
        if ( virhe == null || virhe.isEmpty() ) {
            LabelVirhe.setText("");
            LabelVirhe.getStyleClass().removeAll("virhe");
            return;
        }
        LabelVirhe.setText(virhe);
        LabelVirhe.getStyleClass().add("virhe");
    }

    
    
    /**
     * Näytetään kerän tiedot
     * @param editst taulukko muokattavista
     * @param kera näytettävä kerä
     */
    public void naytaKera(ComboBoxChooser<?> editst[],Kera kera) {
        if (kera == null) return;
        editst[0].getSelectionModel().select(kera.getVariInd());
        editst[1].getSelectionModel().select(kera.getMateriaaliInd());
        editst[2].getSelectionModel().select(kera.getKayttoInd());
        editMaara.setText(kera.getMaara()+"");
        
        if (langat != null) {
            List<Kohteet> hyodynnys = langat.annaHyodynnysKohteet(kera);            
            for (Kohteet kohde : hyodynnys) {
                sb.append(kohde.toString(kohde)).append("\n"); 
            }
            areaHyodynnys.setText(sb.toString());
        } 
    }

    /**
     * Luodaan jäsenen kysymisdialogi ja palautetaan sama tietue muutettuna tai null
     * TODO: korjattava toimimaan
     * @param modalityStage mille ollaan modaalisia, null = sovellukselle
     * @param oletus mitä dataan näytetään oletuksena
     * @param langat langat
     * @param langatgui controlleri
     * @return null jos painetaan Cancel, muuten täytetty tietue
     */
    public static Kera kysyKera(Stage modalityStage, Kera oletus, Langat langat, LangatGUIController langatgui) {
        return ModalController.<Kera, LanganmuokkausController>showModal(
            LanganmuokkausController.class.getResource("Langanmuokkaus.fxml"),
            "Langan muokkaus", 
            modalityStage, oletus, 
            ctrl -> { 
                ctrl.setCtrl(langatgui); 
                ctrl.setLangat(langat); 
                ctrl.setDefault(oletus);
                
            }
        );
    }
    
    
    /**
     * Aettaa kerhon eli langat
     * @param langat langat kerho
     */
    public void setLangat(Langat langat) {
        this.langat = langat;
    }

    /**
     * Asettaa controllerin
     * @param langatgui langatguicontroller
     */
    public void setCtrl(LangatGUIController langatgui) {
        this.langatgui = langatgui;
    }

}
